﻿Imports System.Data
Imports Infragistics.Web.UI.GridControls
Public Class WebForm1
    Inherits System.Web.UI.Page
    Protected WithEvents WebHierarchicalDataGrid1 As Infragistics.Web.UI.GridControls.WebHierarchicalDataGrid
    Dim dsSearch As New DataSet

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ConfigureDataSource()
    End Sub
    Protected Overrides Sub OnInit(e As EventArgs)
        MyBase.OnInit(e)
        AddHandler Me.WebHierarchicalDataGrid1.RowIslandsPopulating, AddressOf WebHierarchicalDataGrid1_RowIslandsPopulating
        AddHandler Me.WebHierarchicalDataGrid1.InitializeRow, AddressOf WebHierarchicalDataGrid1_InitializeRow

        'If Session("DataSet") Is Nothing Then
        '    'Dim repository = New Repository()
        '    Session("DataSet") = getActorList()
        'End If
        If Not Session("DataSet") Is Nothing Then
            Me.WebHierarchicalDataGrid1.DataSource = Session("DataSet")
        End If
    End Sub
    Private Sub ConfigureDataSource()
        If Not IsPostBack Then


            dsSearch.Tables.Add(GetEmployeeData())
            dsSearch.Tables.Add(CreateAccoutTable())
            dsSearch.Tables.Add(CreateRelationshipTable())
            dsSearch.Tables.Add(CreateSystemTable())

            Me.WebHierarchicalDataGrid1.DataSource = dsSearch
            'Me.WebHierarchicalDataGrid1.DataBind()
        End If
    End Sub
    Private Sub WebHierarchicalDataGrid1_InitializeRow(sender As Object, e As RowEventArgs)
        'If e.Row.Index Mod 2 = 0 Then
        '    For i As Integer = 1 To e.Row.Items.Count - 1 Step 2
        '        e.Row.Items(i).CssClass = "chessboard"
        '    Next
        'Else
        '    For i As Integer = 0 To e.Row.Items.Count - 1 Step 2
        '        e.Row.Items(i).CssClass = "chessboard"
        '    Next
        'End If
    End Sub


    'Comment - In fuction GetEmployeeData()- It is loading on page lode- I am getting data from database Oracle stored procedure.As for your understing i took column name added. 
    Private Function GetEmployeeData() As DataTable
        Dim Employee As DataTable = New DataTable("Employee")
        Dim keys(0) As DataColumn
        Dim workCol As DataColumn = Employee.Columns.Add( _
            "E_ID", Type.GetType("System.Int32"))
        workCol.AllowDBNull = False
        workCol.Unique = True
        Employee.Columns.Add("E_TYPE", Type.GetType("System.String"))
        Employee.Columns.Add("E_TRD_IND", Type.GetType("System.String"))
        Employee.Columns.Add("US_Employee", Type.GetType("System.String"))
        keys(0) = workCol
        Employee.PrimaryKey = keys
        Dim R As DataRow = Employee.NewRow
        R("E_ID") = 1232342
        R("E_TYPE") = "Vendor"
        R("E_TRD_IND") = "US"
        R("US_Employee") = "Yes"
        Employee.Rows.Add(R)
        Dim R2 As DataRow = Employee.NewRow
        R2("E_ID") = 123233
        R2("E_TYPE") = "In-House"
        R2("E_TRD_IND") = "UK"
        R2("US_Employee") = "NO"
        Employee.Rows.Add(R2)
        Dim R3 As DataRow = Employee.NewRow
        R3("E_ID") = 1232345
        R3("E_TYPE") = "Vendor"
        R3("E_TRD_IND") = "IND"
        R3("US_Employee") = "NO"
        Employee.Rows.Add(R3)
        Dim R4 As DataRow = Employee.NewRow
        R4("E_ID") = 1232346
        R4("E_TYPE") = "Vendor"
        R4("E_TRD_IND") = "NEW YORK"
        R4("US_Employee") = "YES"
        Employee.Rows.Add(R4)
        Dim R5 As DataRow = Employee.NewRow
        R5("E_ID") = 1232348
        R5("E_TYPE") = "Vendor"
        R5("E_TRD_IND") = "LA"
        R5("US_Employee") = "YES"
        Employee.Rows.Add(R5)
        Return Employee

    End Function
    Private Function CreateAccoutTable() As DataTable
        Dim Account As DataTable = New DataTable("Account")
        Dim keys(0) As DataColumn
        Dim workCol As DataColumn = Account.Columns.Add( _
            "ACCOUNT_ID", Type.GetType("System.Int32"))
        workCol.AllowDBNull = False
        workCol.Unique = True
        Account.Columns.Add("E_TYPE", Type.GetType("System.String"))
        Account.Columns.Add("TYPE_Acct", Type.GetType("System.String"))
        Account.Columns.Add("ACCT_DESC", Type.GetType("System.String"))
        Account.Columns.Add("PTY_ID", Type.GetType("System.Int32"))
        keys(0) = workCol
        Account.PrimaryKey = keys

        'This row will added on Demand'
        Dim R As DataRow = Account.NewRow
        R("ACCOUNT_ID") = 501
        R("E_TYPE") = "Current"
        R("TYPE_Acct") = "Employee"
        R("ACCT_DESC") = "D-mat Account"
        R("PTY_ID") = 123233
        Account.Rows.Add(R)
        Return Account

    End Function
    Private Function CreateRelationshipTable() As DataTable
        Dim Relationship As DataTable = New DataTable("Relationship")
        Dim keys(0) As DataColumn
        Dim workCol As DataColumn = Relationship.Columns.Add( _
            "RELNS_ID", Type.GetType("System.Int32"))
        workCol.AllowDBNull = False
        workCol.Unique = True
        Relationship.Columns.Add("RELNTYPE", Type.GetType("System.String"))
        Relationship.Columns.Add("STATUS", Type.GetType("System.String"))
        Relationship.Columns.Add("BOOKINGENTITY", Type.GetType("System.String"))
        keys(0) = workCol
        Relationship.PrimaryKey = keys
        'This row will added on Demand'
        'Dim R As DataRow = Relationship.NewRow
        'R("E_ID") = 1232342
        'R("E_TYPE") = "Vendor"
        'R("E_TRD_IND") = "US"
        'R("US_Employee") = "Yes"
        'Relationship.Rows.Add(R)
        Return Relationship

    End Function
    Private Function CreateSystemTable() As DataTable
        Dim System As DataTable = New DataTable("System")
        Dim keys(0) As DataColumn
        Dim workCol As DataColumn = System.Columns.Add( _
            "SYSTEM_CODE", Type.GetType("System.Int32"))
        workCol.AllowDBNull = False
        workCol.Unique = True
        System.Columns.Add("SYSTTYPE", Type.GetType("System.String"))
        System.Columns.Add("SYSNAME", Type.GetType("System.String"))
        System.Columns.Add("RELNS_ID", Type.GetType("System.Int32"))
        keys(0) = workCol
        System.PrimaryKey = keys
        'This row will added on Demand'
        'Dim R As DataRow = System.NewRow
        'R("E_ID") = 1232342
        'R("E_TYPE") = "Vendor"
        'R("E_TRD_IND") = "US"
        'R("US_Employee") = "Yes"
        'System.Rows.Add(R)
        Return System

    End Function
    
    Private Function GetAccountData(ByVal E_ID As String, ByVal E_TRD_IND As String, ByVal E_TYPE As String, ByVal US_Employee As String) As DataTable
        Dim Account As DataTable = New DataTable("Account")
        'Take this data on run time on demand- Get data for account from E_ID which is selected from "Employee" table '
        ' For Example- Employee data is populated on page load- now I am selecting 5 row - which is means clicking on (+) sign. 
        ' 5th row ID is E_ID=01234 
        ' Selected Row -And taking all cell (ID="01234",E_TYPE="IT",E_TRD_IND="Yes",US_Employee="NO") data into variables, which we had selected that means 5th row. And passing to stored procedure and returning datatable

        Return Account

    End Function
    Private Function GetRelationshipData(ByVal ACCOUNT_ID As String, ByVal TYPE_Acct As String, ByVal ACCT_DESC As String, ByVal PTY_ID As String) As DataTable
        Dim Relationship As DataTable = New DataTable("Relationship")
        'Take relationship data from account id which is selected'
        'Take this data on run time on demand'
        Return Relationship

    End Function
    Private Function GetSystemData(ByVal RELNS_ID As String, ByVal RELNTYPE As String, ByVal STATUS As String, ByVal BOOKINGENTITY As String) As DataTable
        Dim System As DataTable = New DataTable("System")
        'Take System data from Relationship id which is selected'
        'Take this data on run time on demand'
        Return System

    End Function
    Sub WebHierarchicalDataGrid1_RowIslandsPopulating(sender As Object, e As ContainerRowCancelEventArgs)
        e.Cancel = True

        Dim dataSet = TryCast(Session("DataSet"), DataSet)

        Dim childTable As New DataTable
        'Query comment- How can select row data?
        Select Case e.Row.Level
            Case 0 'Employee row is selected which is 5th Row
                'I am not sure about syntex- But I want selected row for band 0- represnt Employee Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(0), ContainerGridRecord)
                Dim EmployeeID As String = rec.DataKey("E_ID")
                Dim Emp_E_TRD_IND As String = rec.DataKey("E_TRD_IND")
                Dim Emp_E_TYPE As String = rec.DataKey("E_TYPE")
                Dim Emp_US_Employee As String = rec.DataKey("US_Employee")

                'Assume that we got 5 rows relationship row  from E_ID'
                childTable = GetAccountData(EmployeeID, Emp_E_TRD_IND, Emp_E_TYPE, Emp_US_Employee)

                'Query comment- How can i bind more row in parent table after clicking on child, without postback of page ?
                'Custome logic for Employee Datatable'
                '***************Very Importent point********************** please implement it
                ' For Example if I have 10 row in parent table(Employee) and on 5th row selection below condition set true-
                ' There is 5 more row I need to add in parent table(Employee) and bind it without refreshing page and page count from 1 to 2- And Row will be from 10 to 15 rows
                ' If (Some Condition here )=True  then

                ' Need to extra rows in partent Table (Employee) bind it 
                ' End If

                childTable.TableName = "Account"
                dsSearch.Tables.Add(childTable)
                If (dsSearch.Tables("Account").Rows.Count > 0) Then
                    dsSearch.Relations.Add("PK", dsSearch.Tables("Employee").Columns("CST_ID"), dsSearch.Tables("Account").Columns("PTY_ID"), False)
                End If
            Case 1
                'Account row is selected which is 2th Row
                'I am not sure about syntex- But I want selected row for band 1- represnt Account row selection Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(1), ContainerGridRecord)
                Dim ACCOUNTID As String = rec.DataKey("ACCOUNT_ID")
                Dim TYPEAcct As String = rec.DataKey("TYPE_Acct")
                Dim ACCTDESC As String = rec.DataKey("ACCT_DESC")
                Dim PTYID As String = rec.DataKey("PTY_ID")

                'Assume that we got 5 rows relationship row from ACCOUNT_ID'
                childTable = GetRelationshipData(ACCOUNTID, TYPEAcct, ACCTDESC, PTYID)

                childTable.TableName = "Relationship"
                dsSearch.Tables.Add(childTable)

                If (dsSearch.Tables("Relationship").Rows.Count > 0) Then
                    dsSearch.Relations.Add("FK", dsSearch.Tables("Account").Columns("ACCT_ID"), dsSearch.Tables("Relationship").Columns("ACCT_ID"), False)
                End If
            Case 2
                'relationship row is selected which is 3th Row
                'I am not sure about syntex- But I want selected row for band 2- represnt Account row selection Table '
                Dim rec As ContainerGridRecord = DirectCast(Me.WebHierarchicalDataGrid1.GridView.Behaviors.Selection.SelectedRows(2), ContainerGridRecord)
                Dim RELNSID As String = rec.DataKey("RELNS_ID")
                Dim RELNTYPE As String = rec.DataKey("RELNTYPE")
                Dim STATUS As String = rec.DataKey("STATUS")
                Dim BOOKINGENTITY As String = rec.DataKey("BOOKINGENTITY")

                'Assume that we got 5 rows relationship row from ACCOUNT_ID'
                childTable = GetSystemData(RELNSID, RELNTYPE, STATUS, BOOKINGENTITY)
                childTable.TableName = "System"
                dsSearch.Tables.Add(childTable)
                If (dsSearch.Tables("System").Rows.Count > 0) Then
                    dsSearch.Relations.Add("RK", dsSearch.Tables("Relationship").Columns("RELNS_ID"), dsSearch.Tables("System").Columns("RELNS_ID"), False)
                End If
        End Select

        Dim childGrid As New ContainerGrid()

        e.Row.RowIslands.Add(childGrid)
        childGrid.DataSource = childTable
        childGrid.DataBind()
    End Sub
  
End Class

